#!/bin/bash
set -e

sys_root_dir=null

function usage() {
    echo -e "Usage:\n$0 <sys_root_dir>"
}

function main() {
    if [ $# -le 0 ]; then
        usage
        exit 1
    fi

    sys_root_dir=$1

    if [ ! -d build ]; then
        mkdir -p build
    else
        rm -rf build/*
    fi

    cd build

    # Run CMake with the specified SYSROOT_PATH and NOT_BUILDROOT options
    cmake .. -DNOT_BUILDROOT=ON -DSYSROOT_PATH=${sys_root_dir}

    make
}

main $@
